package at.jku.ssw.pi.heap.ue06;

import java.util.Arrays;
import java.util.Comparator;

import at.jku.ssw.pi.Iterator;
import at.jku.ssw.pi.heap.PriorityQueue;
import at.jku.ssw.pi.util.DotMaker;

@SuppressWarnings({ "rawtypes", "unchecked" })
public class ArrayPriorityQueue extends PriorityQueue implements Cloneable {

	// As discussed during the lecture:
	private final Comparator comparator;
	private Object[] values;
	private int count;

	// As discussed during the lecture:
	public ArrayPriorityQueue(Comparator cmp) {
		this.comparator = cmp;
		clear();
	}

	// As discussed during the lecture:
	private ArrayPriorityQueue(ArrayPriorityQueue other) {
		this.comparator = other.comparator; // better be stateless
		this.values = Arrays.copyOf(other.values, other.values.length);
		this.count = other.count;
	}

	// TODO: UE06
	@Override
	public void offer(Object value) {
		// TODO UE06
	}

	// TODO: UE06
	@Override
	public boolean contains(Object value) {
		// TODO UE06
		return false;
	}

	// TODO: UE06
	@Override
	public Object poll() {
		// TODO UE06
		return null;
	}

	// TODO: UE06
	@Override
	public int size() {
		// TODO UE06
		return 0;
	}

	// As discussed during the lecture:
	@Override
	protected ArrayPriorityQueue clone() {
		return new ArrayPriorityQueue(this);
	}

	// As discussed during the lecture:
	@Override
	public Iterator iterator() {
		return new ArrayPriorityQueueIterator(clone());
	}

	// TODO: UE06
	@Override
	public void clear() {
		// TODO UE06
	}

	// TODO: UE06
	@Override
	public Object peek() {
		// TODO UE06
		return null;
	}

	// TODO: UE06
	@Override
	public boolean remove(Object value) {
		// TODO UE06
		return false;
	}

	// As discussed during the lecture:
	public String makeDot() {
		return DotMaker.makeDotForHeap(Arrays.copyOf(values, count));
	}
}